// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	test the AbsorptionDataServer class
//
#include <iostream>
#include <cassert>
#include "CalServer.h"
#include "Ccf.h"
#include "EqpbServer.h"

using namespace std;

/*
namespace {
bool isClose(double a, double b)
{
    return fabs(a)/fabs(b)-1. < 1.e-5;
}
}
*/

int main()
{
	//	setup the the Cal server
	Xmm::Instrument instrument = Xmm::EPN;
	calServer.setInstrument(instrument);

	//	get the DataServer
	EqpbServer *eq = 0; eq = calServer.getAtom(eq);

        // Get all the data
        EqpbServer::QpbData qd = eq->qpbData();

        // Display some values
        cout<<"Quad[0]:"<<qd.quad[0]<<endl;;
        cout<<"Quad[0]:"<<qd.quad[99]<<endl;;
        cout<<"Total_t[0]:"<<qd.total_t[0]<<endl;;
        cout<<"Total_t[99]:"<<qd.total_t[99]<<endl;;
        cout<<"Obsid[0]:"<<qd.obsid[0]<<endl;;
//        cout<<qd.total_t[1];
        cout<<"Back[2]:"<<qd.backscal[2]<<endl;;
        cout<<"Spec0: "<<qd.specp0[100][100]<<endl;
        cout<<"Spec0: "<<qd.specoop0[100][100]<<endl;
        cout<<"Spec0: "<<qd.specp4[100][100]<<endl;
        cout<<"Spec0: "<<qd.specoop4[100][100]<<endl;
    //    cout<<qd.object[2];
	return 0;
}







