! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!
!   timejumptest.f90  --- f90 program to test the time jump access CAL routines
!
!   DESCRIPTION:
!       This gets the time jump tolerance for a given revlution
!
program caltest_swcx

use cal             ! use the Calibration Access Layer
use dal
use errorhandling

    implicit none
    character(len=6)               :: line
    real(single), dimension(:,:), pointer :: map

    call CAL_setState(instrument=EMOS1)
    call CAL_setState(filterId=THIN1)

    line='OVII  '
    call CAL_swcxmap(line, map)  

    write(*,*)'MOS1: line, Map: ',line,map(0,0),map(300,149)

    line='NEIX'
    call CAL_swcxmap(line, map)  

    write(*,*)'MOS1: line, Map: ',line,map(0,0),map(300,149)

end program


