! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!
!   vectorconv.f90 --- test int->real->int vector conversion of CAL
!
!   AUTHOR:
!       U. Lammers, Tue Jun  1 15:32:29 MET DST 1999
!
!   $Header: /sasbuild/sas_git_repo/cvs_copy/sasdev/sas/packages/cal/f90test/vectorconv.f90,v 1.3 2003/10/03 14:15:40 sasbuild Exp $
!
program vectorconv

use cal             ! use the Calibration Access Layer
use dal
implicit none

    integer i
    type(DataSetT) set
    type(TableT) tab
    type(ColumnT) col1, col2, col3, col4
    integer(kind=int16), dimension(:), pointer :: i161 => null(), i162 => null()
    real(kind=single), dimension(:), pointer :: r321 => null(), r322 => null() , r32null => null()
    integer, parameter                       :: nRows = 100

    set = dataSet("test.dat",CREATE)
    tab = addTable(set,"some table",nRows)
    col1 = addColumn(tab, "INT1", INTEGER16, "none")
    col2 = addColumn(tab, "REAL1", REAL32, "none")
    col3 = addColumn(tab, "REAL2", REAL32, "none")
    col4 = addColumn(tab, "INT2", INTEGER16, "none")

    i161 => int16Data(col1)
    r321 => real32Data(col2)
    r322 => real32Data(col3)
    i162 => int16Data(col4)

    do i=0,nRows-1
       i161(i) = i;
    enddo

    call CAL_setRandom(-.5_double, .5_double)
    call CAL_setState(randomize = .true.)
    call CAL_integerToReal(i161, r321)
    call CAL_setState(randomize = .false.)
    call CAL_integerToReal(i161, r322)
    call CAL_setState(randomize = .true.)
    call CAL_integerToReal(i161, r32null)

    do i=0, nRows-1
       write(*, *) r32null(i)
    enddo
    call CAL_releaseMemory(r32null)

    call CAL_realToInteger(r321, i162)
    do i=0, nRows-1
       if (i161(i) /= i162(i) .or. i161(i) /= int(r322(i))) &
           call fatal('vectorconv', 'integer vectors different')
    enddo

    call release(set)

end program vectorconv

